summaryrefslogtreecommitdiff
path: root/net.Linux/ccwgroup.sh
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
committerRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
commit5af58b45146ab5253ca964738f4e45287bf963d4 (patch)
tree68d3a9a61fa55dd7fe273db776c375f797edaa5b /net.Linux/ccwgroup.sh
downloadopenrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.gz
openrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.bz2
openrc-5af58b45146ab5253ca964738f4e45287bf963d4.tar.xz
Rewrite the core parts in C. We now provide librc so other programs can
query runlevels, services and state without using bash. We also provide libeinfo so other programs can easily use our informational functions. As such, we have dropped the requirement of using bash as the init script shell. We now use /bin/sh and have strived to make the scripts as portable as possible. Shells that work are bash and dash. busybox works provided you disable s-s-d. If you have WIPE_TMP set to yes in conf.d/bootmisc you should disable find too. zsh and ksh do not work at this time. Networking support is currently being re-vamped also as it was heavily bash array based. As such, a new config format is available like so config_eth0="1.2.3.4/24 5.6.7.8/16" or like so config_eth0="'1.2.3.4 netmask 255.255.255.0' '5.6.7.8 netmask 255.255.0.0'" We will still support the old bash array format provided that /bin/sh IS a link it bash. ChangeLog for baselayout-1 can be found in our SVN repo.
Diffstat (limited to 'net.Linux/ccwgroup.sh')
-rw-r--r--net.Linux/ccwgroup.sh66
1 files changed, 66 insertions, 0 deletions
diff --git a/net.Linux/ccwgroup.sh b/net.Linux/ccwgroup.sh
new file mode 100644
index 0000000..1cba04c
--- /dev/null
+++ b/net.Linux/ccwgroup.sh
@@ -0,0 +1,66 @@
+# Copyright 2006-2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# Contributed by Roy Marples (uberlord@gentoo.org)
+
+_config_vars="$_config_vars ccwgroup"
+
+ccwgroup_depend() {
+ before interface
+}
+
+ccwgroup_pre_start() {
+ eval $(_get_array "ccwgroup_${IFVAR}")
+ [ $# = "0" ] && return 0
+
+ if [ ! -d /sys/bus/ccwgroup ] ; then
+ modprobe qeth
+ if [ ! -d /sys/bus/ccwgroup ] ; then
+ eerror "ccwgroup support missing in kernel"
+ return 1
+ fi
+ fi
+
+ einfo "Enabling ccwgroup on ${IFACE}"
+ local x= ccw= first= layer2=
+ for x in "$@" ; do
+ [ -z "${first}" ] && first=${x}
+ ccw="${ccw}${ccw:+,}${x}"
+ done
+ if [ -e /sys/devices/qeth/"${first}" ] ; then
+ echo "0" > /sys/devices/qeth/"${first}"/online
+ else
+ echo "${ccw}" > /sys/bus/ccwgroup/drivers/qeth/group
+ fi
+ eval layer2=\$qeth_layer2_${IFVAR}
+ echo "${layer2:-0}" > /sys/devices/qeth/"${first}"/layer2
+ echo "1" > /sys/devices/qeth/"${first}"/online
+ eend $?
+}
+
+ccwgroup_pre_stop() {
+ # Erase any existing ccwgroup to be safe
+ save_options ccwgroup_device ""
+
+ [ ! -L /sys/class/net/"${FACE}"/driver ] && return 0
+ local driver="$(readlink /sys/class/net/"${IFACE}"/driver)"
+ case "${diver}" in
+ */bus/ccwgroup/*) ;;
+ *) return 0 ;;
+ esac
+
+ local device="$(readlink /sys/class/net/"${IFACE}"/device)"
+ device=${device##*/}
+ save_options ccwgroup_device "${device}"
+}
+
+ccwgroup_post_stop() {
+ local device="$(get_options ccwgroup_device)"
+ [ -z "${device}" ] && return 0
+
+ einfo "Disabling ccwgroup on ${iface}"
+ echo "0" > /sys/devices/qeth/"${device}"/online
+ echo "1" > /sys/devices/qeth/"${device}"/ungroup
+ eend $?
+}
+
+# vim: set ts=4 :